package main

import (
	"fmt"
	"github.com/smallstep/certificates/ca/identity"
	"os"
	"plugin"
)

type LocalPlugin interface {
	LoadDefaultIdentity() (*identity.Identity, error)
}

func main() {
	p, err := plugin.Open(os.Args[1])
	if err != nil {
		panic(err)
	}

	symbol, err := p.Lookup("MyPlugin")
	if err != nil {
		panic(err)
	}

	var lp LocalPlugin
	lp, ok := symbol.(LocalPlugin)
	if !ok {
		panic("unexpected type from module symbol")
	}

	fmt.Println(lp)
}
